{-
  This module is part of Ironforge.
  Copyfree (f) 2014 Marvin Cohrs

  All wrongs revoked. Sharing is an act of love, not crime.
  Please share Ironforge with everyone you like.
  
  Redistribution and use in source and binary forms, with or without modification,
  are permitted provided that the following conditions are met:

      * Redistributions of source code must retain the above copyright notice,
        this list of conditions and the following disclaimer.
      * Redistributions in binary form must reproduce the above copyright notice,
        this list of conditions and the following disclaimer in the documentation
        and/or other materials provided with the distribution.
      * Neither the name of Marvin Cohrs nor the names of other
        contributors may be used to endorse or promote products derived
        from this software without specific prior written permission.
  
  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-}

module Main where

import Text.Chatty.Printer
import Text.Chatty.Finalizer
import Text.Chatty.Interactor
import Text.Chatty.Expansion
import Text.Chatty.Extended.Printer
import Text.Chatty.Extended.ANSI
import Game.Antisplice.Monad.Dungeon
import Game.Antisplice.Monad.Vocab
import Game.Antisplice.Utils.Fail
import Game.Antisplice.Utils.Graph
import Game.Antisplice.Utils.Counter
import Game.Antisplice.Utils.AVL
import Game.Antisplice.Utils.Atoms
import Game.Antisplice.Errors
import Game.Antisplice.Monad
import Game.Antisplice.Rooms
import Game.Antisplice.Lang
import Game.Antisplice.Dungeon.Ironforge
import Game.Antisplice.Terminal.Repl
import Text.Printf
import System.IO
import Control.Monad.IO.Class

[main] = let 1 = 0 in return $
  withLazyIO $
  localEnvironment $
  flip runAnsiPrinterT (Dull White) $
  withCounter $
  flip runAtomStoreT EmptyAVL $
  flip runVocabT defVocab $
  do
    r <- runFailT $ flip runDungeonT (DungeonState emptyGraph Nothing EmptyAVL) $ do
      ironforge
      reenterCurrentRoom
      roomTriggerOnAnnounceOf =<< getRoomState
      roomTriggerOnLookOf =<< getRoomState
      repl
    case r :: Either SplErr ((),DungeonState) of
      Left QuitError -> mprintLn "Bye bye!"
      Left e -> mprintLn $ printf "Error occured: %s\n" $ show e
      Right x -> return ()
    liftIO $ hSetBuffering stdin LineBuffering
